	include "tios.h"
	include "flib.h"
	include "ffp68343.h"
	xdef _main
	xdef _comment

;********************************
_redrawscreen:
	jsr	flib::clr_scr		; Clear screen

	pea	hello(pc)		; Show program title
	jsr	tios::ST_showHelp	;
	lea	4(sp),sp		;
	rts

_result:
	move.w	#4,-(sp)		; Show DONE string
	pea	done(pc)		;
	move.w	#70,-(sp)		;
	move.w	#25,-(sp)		;
	jsr	tios::DrawStrXY		;
	lea	10(sp),sp		;	
	jsr	flib::idle_loop		; Wait for key press
	rts

_main:
	move.w	#0,-(sp)		; Set IDLE
	jsr	tios::ST_busy		;
	lea	2(sp),sp		;

	move.w	#0,-(sp)		; Set font
	jsr	tios::FontSetSys	;
	lea	2(sp),sp		;

	lea	asciipi(pc),a0		; Convert PI to float
	jsr	ffp68343::ffpafp	;
        move.l  d7,floatpi

	lea	asciie(pc),a0		; Convert e to float
	jsr	ffp68343::ffpafp	;
        move.l  d7,floate

	bsr	_redrawscreen		; Clear screen
	jsr	flib::idle_loop		; Wait for key press

_ffpaddtest:
	bsr	_redrawscreen		; Clear screen and add title
	move.w	#4,-(sp)		;
	pea	msgadd(pc)		;
	move.w	#58,-(sp)		;
	move.w	#4,-(sp)		;
	jsr	tios::DrawStrXY		;
	lea	10(sp),sp		;
					; Perform Test
	move.w	#50000,d2
        move.l  floatpi(pc),d6          ; move pi
addloop:
        move.l  floate(pc),d7           ; reload e
	jsr	ffp68343::ffpadd	; add
	dbra	d2,addloop		;	
	bsr	_result

_ffpmultest:
	bsr	_redrawscreen		; Clear screen and add title
	move.w	#4,-(sp)		;
	pea	msgmul(pc)		;
	move.w	#58,-(sp)		;
	move.w	#4,-(sp)		;
	jsr	tios::DrawStrXY		;
	lea	10(sp),sp		;
					; Perform Test
	move.w	#50000,d2
        move.l  floatpi(pc),d6          ; move pi
mulloop:
        move.l  floate(pc),d7           ; reload e
	jsr	ffp68343::ffpmul
	dbra	d2,mulloop		;	
	bsr	_result

_ffpdivtest:
	bsr	_redrawscreen		; Clear screen and add title
	move.w	#4,-(sp)		;
	pea	msgdiv(pc)		;
	move.w	#58,-(sp)		;
	move.w	#4,-(sp)		;
	jsr	tios::DrawStrXY		;
	lea	10(sp),sp		;
					; Perform Test
	move.w	#50000,d2
        move.l  floatpi(pc),d6          ; move pi
divloop:
        move.l  floate(pc),d7           ; reload e
	jsr	ffp68343::ffpdiv
	dbra	d2,divloop		;	
	bsr	_result

_ffpsqrtest:
	bsr	_redrawscreen		; Clear screen and add title
	move.w	#4,-(sp)		;
	pea	msgadd(pc)		;
	move.w	#58,-(sp)		;
	move.w	#4,-(sp)		;
	jsr	tios::DrawStrXY		;
	lea	10(sp),sp		;
					; Perform Test
	move.w	#20000,d2
sqrloop:
        move.l  floatpi(pc),d7 
	jsr	ffp68343::ffpsqrt
	dbra	d2,sqrloop		;	
	bsr	_result

_ffpsintest:
	bsr	_redrawscreen		; Clear screen and add title
	move.w	#4,-(sp)		;
	pea	msgsin(pc)		;
	move.w	#58,-(sp)		;
	move.w	#4,-(sp)		;
	jsr	tios::DrawStrXY		;
	lea	10(sp),sp		;
					; Perform Test
	move.w	#10000,d2
sinloop:
        move.l  floate(pc),d7 
	jsr	ffp68343::ffpsincs
	dbra	d2,sinloop		;	
	bsr	_result
          
_quit:
	rts

;********************************
floatpi dc.l    0
floate  dc.l    0

asciipi	dc.b	"+3.1415926535897 "
asciie	dc.b	"+2.718281828459045 "

hello	dc.b	"ffp68343 fast floating point demo",0
msgadd	dc.b	"fifty thousand additions of 3.14159265 to 2.718281828",0
msgmul	dc.b	"fifty thousand multiplies of 3.14159265 with 2.718281828",0
msgdiv	dc.b	"fifty thousand divides of 3.14159265 into 2.718281828",0
msgsqr	dc.b	"twenty thousand square roots of 3.14159265",0
msgsin	dc.b	"ten thousand cosines and sines of 2.71828128",0
done	dc.b	"Done!",0
_comment	dc.b	"ffp68343 Demo",0

	end
